
# Message

- category: Components
- chinese: 消息提示
- type: 基本

---

全局展示操作反馈信息。



## 何时使用

- 可提供成功、警告和错误等反馈信息。
- 顶部居中显示并自动消失，是一种不打断用户操作的轻量级提示方式。



## API

- 属性说明如下：

属性         | 类型           | 默认值   | 说明
-----        |-----           |-----     |------
text         |  string        | ''       | 提示文本
duration     |  Int           | 3000     | 提示显示X 毫秒(ms)后消失
type         |  string        | 'default'| 类型，默认样式 ['default', 'fixedly', 'movememt']


- Demo

```
Message.show(<Message>some message</Message>)
Message.show(<Message text="hello world" duration={2000}/>)
Message.show("hello world", 2000)
```
