'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames5 = require('classnames');

var _classnames6 = _interopRequireDefault(_classnames5);

var _reactDom = require('react-dom');

var instances_hide = [];

var Message = (function (_React$Component) {
    _inherits(Message, _React$Component);

    function Message() {
        _classCallCheck(this, Message);

        _get(Object.getPrototypeOf(Message.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(Message, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var hide = instances_hide.pop();
            hide && (this.timeid = hide());
        }
    }, {
        key: 'renderDefault',
        value: function renderDefault() {
            var _classnames,
                _this = this;

            var _props = this.props;
            var className = _props.className;
            var children = _props.children;

            var others = _objectWithoutProperties(_props, ['className', 'children']);

            var classes = (0, _classnames6['default'])((_classnames = {}, _defineProperty(_classnames, 'Message--tips', true), _defineProperty(_classnames, className, className), _classnames));

            return _react2['default'].createElement(
                'div',
                _extends({ className: classes }, others, { ref: function (ref) {
                        return _this.target = ref;
                    } }),
                _react2['default'].createElement(
                    'div',
                    { className: 'Message--tips__text' },
                    children || this.props.text
                )
            );
        }
    }, {
        key: 'renderFixedly',
        value: function renderFixedly() {
            var _classnames2,
                _this2 = this;

            var _props2 = this.props;
            var className = _props2.className;
            var children = _props2.children;

            var others = _objectWithoutProperties(_props2, ['className', 'children']);

            var classes = (0, _classnames6['default'])((_classnames2 = {}, _defineProperty(_classnames2, 'Message--tips-fixedly', true), _defineProperty(_classnames2, className, className), _classnames2));

            return _react2['default'].createElement(
                'div',
                _extends({ className: classes }, others, { ref: function (ref) {
                        return _this2.target = ref;
                    } }),
                _react2['default'].createElement(
                    'div',
                    { className: 'Message--tips-fixedly__text' },
                    children || this.props.text
                )
            );
        }
    }, {
        key: 'renderMovement',
        value: function renderMovement() {
            var _classnames3,
                _this3 = this;

            var _props3 = this.props;
            var className = _props3.className;
            var children = _props3.children;

            var others = _objectWithoutProperties(_props3, ['className', 'children']);

            var classes = (0, _classnames6['default'])((_classnames3 = {}, _defineProperty(_classnames3, 'Message--tips-movement fadeInDown', true), _defineProperty(_classnames3, className, className), _classnames3));

            return _react2['default'].createElement(
                'div',
                _extends({ className: classes }, others, { ref: function (ref) {
                        return _this3.target = ref;
                    } }),
                _react2['default'].createElement(
                    'div',
                    { className: 'Message--tips-movement__text' },
                    children || this.props.text
                )
            );
        }
    }, {
        key: 'renderDebugger',
        value: function renderDebugger() {
            var _classnames4,
                _this4 = this;

            var _props4 = this.props;
            var className = _props4.className;
            var children = _props4.children;

            var others = _objectWithoutProperties(_props4, ['className', 'children']);

            var classes = (0, _classnames6['default'])((_classnames4 = {}, _defineProperty(_classnames4, 'Message--tips-debugger fadeInDown', true), _defineProperty(_classnames4, className, className), _classnames4));

            return _react2['default'].createElement(
                'div',
                _extends({ className: classes }, others, { ref: function (ref) {
                        return _this4.target = ref;
                    } }),
                _react2['default'].createElement(
                    'div',
                    { className: 'Message--tips-debugger__text' },
                    children || this.props.text
                )
            );
        }
    }, {
        key: 'render',
        value: function render() {
            switch (this.props.type) {
                case 'fixedly':
                    return this.renderFixedly();
                case 'movement':
                    return this.renderMovement();
                case 'debugger':
                    return this.renderDebugger();
                default:
                    return this.renderDefault();
            }
        }
    }]);

    return Message;
})(_react2['default'].Component);

exports['default'] = Message;

Message.propTypes = {
    className: _react2['default'].PropTypes.string
};

Message.show = function (message, node) {

    if (typeof message == 'string') {
        var duration = typeof node === 'number' ? node : 3000;
        message = _react2['default'].createElement(Message, { text: message, duration: duration });
    }

    var target = document.createElement('div');
    var parent = typeof node === 'object' ? node : document.body;

    if (message.props.type == 'debugger') {
        var debuggerContainer = document.getElementById('debuggerContainer');
        if (!debuggerContainer) {
            var container = document.createElement('div');
            container.id = 'debuggerContainer';
            container.style.cssText = 'position:fixed;left:10px;right:10px;top:0px;z-index:999';
            document.body.appendChild(container);
            parent = container;
        } else {
            parent = debuggerContainer;
        }
    }

    parent.insertBefore(target, parent.firstElementChild);

    var hide = function hide() {
        return setTimeout(function () {
            (0, _reactDom.unmountComponentAtNode)(target);
            parent.removeChild(target);
        }, parseInt(message.props.duration || 3000));
    };
    instances_hide.push(hide);

    (0, _reactDom.render)(message, target);
};
module.exports = exports['default'];