# 微票儿 公共组件库
[![NPM Version](http://img.shields.io/npm/v/vision-ui-ext.svg?style=flat)](https://www.npmjs.org/package/vision-ui-ext)
[![NPM Downloads](https://img.shields.io/npm/dm/vision-ui-ext.svg?style=flat)](https://www.npmjs.org/package/vision-ui-ext)
### Install

```
npm install vision-ui-ext --save

```

#### step1

*  create `vision.scss` under your scss fold as followings

```
@import
    'vision-ui/components/variables',
    'my-theme.scss',
    'vision-ui-ext/components/components'
```

#### step2

* using custom theme
```
// in your js file
import custom_vision_ui from 'scss/vision'
import { Blank } from 'vision-ui-ext'
```

### Build and Publish

#### Dev 开发

```
npm install
npm start # open page http://localhost:8080
```
* Component => `components/COMPONENT/index.js`
* Style => `components/COMPONENT/style.scss`
* related Demo =>  `example/pages/COMPONENT/index.js`
* Docs =>  `docs/COMPONENT.md`

#### Publish

```
npm run build
npm publish
```
