# DatePicker

- category: Components
- chinese: 时间选择器
- type: 基本

## 何时使用

移动端选择日期时


## API

- 时间选择器的属性说明如下：

属性             | 类型     | 默认值              | 说明
-----            | -----    |-----                |------
value             Date   |  new Date            日期现在的值 |
min             | Date   |  new Date(1970,0,1)| 日期最小值
max            | Date   |  new Date(2050,0,1)| 日期最大值
onSelect      | Function | `(value) => {}` |   在选择日期后触发，参数为现在日期的值
onCancel      Function    `() => {}`        关闭组件
loopAdd       Bool        false           例如月份从1月滚到12月，之后又到1月，此时年份是否加一年，为true则加
showButton    Bool        false           是否展示按钮，如果展示则在点击完成按钮后更新时间，否则在滚动停止后更新时间。
type          string       'small'         展示不同大小的日期选择器small:3行 middle: 7行  large: 11行

- Demo

```
<DatePicker
    value={this.state.time}
     onSelect={(value) => { this.setState({ time: value }) } />

```
