'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DatePickerJs = require('./DatePicker.js');

var _DatePickerJs2 = _interopRequireDefault(_DatePickerJs);

var ModalDatePicker = (function (_React$Component) {
    _inherits(ModalDatePicker, _React$Component);

    function ModalDatePicker() {
        _classCallCheck(this, ModalDatePicker);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        _get(Object.getPrototypeOf(ModalDatePicker.prototype), 'constructor', this).apply(this, args);
    }

    _createClass(ModalDatePicker, [{
        key: 'render',
        value: function render() {
            return _react2['default'].createElement(_DatePickerJs2['default'], this.props);
        }
    }]);

    return ModalDatePicker;
})(_react2['default'].Component);

exports['default'] = ModalDatePicker;

ModalDatePicker.propTypes = {
    value: _react.PropTypes.object,
    min: _react.PropTypes.object,
    max: _react.PropTypes.object,
    loopAdd: _react.PropTypes.bool,
    showButton: _react.PropTypes.bool,
    dateFormat: _react.PropTypes.array,
    onSelect: _react.PropTypes.func,
    onCancel: _react.PropTypes.func
};

ModalDatePicker.defaultProps = {
    value: new Date(),
    min: new Date(1970, 0, 1),
    max: new Date(2050, 0, 1),
    loopAdd: false,
    showButton: false,
    dateFormat: ['YYYY', 'M', 'D'],
    onSelect: function onSelect() {},
    onCancel: function onCancel() {},
    type: 'small'
};
module.exports = exports['default'];