'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});
var TRANSITION = null;
var TRANSITIONEND = null;
var TRANSITION_CSS = null;
if (typeof document.body.style.transition === 'string') {
    exports.TRANSITION = TRANSITION = 'transition';
    exports.TRANSITIONEND = TRANSITIONEND = 'transitionend';
    exports.TRANSITION_CSS = TRANSITION_CSS = 'transition';
} else if (typeof document.body.style.webkitTransition === 'string') {
    exports.TRANSITION = TRANSITION = 'WebkitTransition';
    exports.TRANSITION_CSS = TRANSITION_CSS = '-webkit-transition';
    exports.TRANSITIONEND = TRANSITIONEND = 'webkitTransitionEnd';
}

var TRANSFORM = null;
var TRANSFORM_CSS = null;
if (typeof document.body.style.transform === 'string') {
    exports.TRANSFORM = TRANSFORM = 'transform';
    exports.TRANSFORM_CSS = TRANSFORM_CSS = 'transform';
} else if (typeof document.body.style.webkitTransform === 'string') {
    exports.TRANSFORM = TRANSFORM = 'WebkitTransform';
    exports.TRANSFORM_CSS = TRANSFORM_CSS = '-webkit-transform';
}

exports.TRANSITION = TRANSITION;
exports.TRANSITIONEND = TRANSITIONEND;
exports.TRANSITION_CSS = TRANSITION_CSS;
exports.TRANSFORM = TRANSFORM;
exports.TRANSFORM_CSS = TRANSFORM_CSS;